package it.micegroup.gestioneferie.pianificazioneferie.assembler;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;
import org.springframework.hateoas.CollectionModel;
import org.springframework.hateoas.Link;
import org.springframework.stereotype.Component;

import it.micegroup.gestioneferie.libs.assembler.BaseModelAssembler;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DperiodiAmmtoPfController;
import it.micegroup.gestioneferie.pianificazioneferie.dto.DperiodiAmmtoPfDto;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DperiodiAmmtoPf;

import it.micegroup.gestioneferie.pianificazioneferie.controller.DpianificFerieAmmtoController;

@Component
public class DperiodiAmmtoPfModelAssembler
		extends BaseModelAssembler<DperiodiAmmtoPf, DperiodiAmmtoPfDto, DperiodiAmmtoPfController> {

	@Override
	public DperiodiAmmtoPfDto toModel(DperiodiAmmtoPf dperiodiAmmtoPf) {
		DperiodiAmmtoPfDto dperiodiAmmtoPfDto = map(dperiodiAmmtoPf, DperiodiAmmtoPfDto.class,
				DperiodiAmmtoPfController.class);

		// SELF LINK
		Link selfLink = convert(
				linkTo(methodOn(DperiodiAmmtoPfController.class).getByObjectKey(dperiodiAmmtoPf.getObjectKey()))
						.withSelfRel());
		dperiodiAmmtoPfDto.add(selfLink);

		// PARENT LINKS
		if (dperiodiAmmtoPf.getTheDpianificFerieAmmto() != null) {
			Link dpianificFerieAmmtoLink = convert(linkTo(methodOn(DpianificFerieAmmtoController.class)
					.getByObjectKey(dperiodiAmmtoPf.getTheDpianificFerieAmmtoObjectKey()))
							.withRel("theDpianificFerieAmmto"));
			dperiodiAmmtoPfDto.add(dpianificFerieAmmtoLink);
		}

		// CHILDREN LINKS

		// PARENTS LINKS FOR IMPORTED MS

		// CHILDREN LINKS FOR IMPORTED MS

		return dperiodiAmmtoPfDto;

	}

	@Override
	public CollectionModel<DperiodiAmmtoPfDto> toCollectionModel(Iterable<? extends DperiodiAmmtoPf> entities) {
		CollectionModel<DperiodiAmmtoPfDto> collectionEntities = super.toCollectionModel(entities);
		// collectionEntities.add(linkTo(methodOn(OrdineController.class).findPaginated(null,
		// null)).withSelfRel());

		return collectionEntities;
	}

}

